//
//  DatabaseViewController.m
//  Database
//
//  Created by koreait on 2014. 11. 4..
//  Copyright (c) 2014년 koreait. All rights reserved.
//

#import "DatabaseViewController.h"

@interface DatabaseViewController ()

@end

@implementation DatabaseViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	NSString *docsDir;
    NSArray *dirPaths;
    
    //documents디렉토리 경로 구함
    dirPaths=NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    docsDir=dirPaths[0];
    //DB파일 경로 구함
    _databasePath=[[NSString alloc] initWithString:[docsDir stringByAppendingPathComponent:@"contacts.sqlite"]];
    //파일매니져생성
    NSFileManager *filemgr=[NSFileManager defaultManager];
    //DB파일이 존재하지 않으면 파일과 테이블을 생성한다.
    if([filemgr fileExistsAtPath:_databasePath]==NO){
        //String을 UTF8로 변환. sqlite3관련 함수에사용
        const char *dbpath=[_databasePath UTF8String];
        //DB오픈. 없으면 생성
        if(sqlite3_open(dbpath, &_contactDB)==SQLITE_OK){
            char *errMsg;
            const char *sql_stmt="create table if not exists contacts2( id integer primary key autoincrement, name text, address text, phone text)";
            if(sqlite3_exec(_contactDB, sql_stmt, NULL, NULL, &errMsg)!=SQLITE_OK){
                _status.text=@"테이블 생성 실패";
            }
            sqlite3_close(_contactDB);
        }else{
            _status.text=@"DB 오픈/생성 실패";
        }
    }
    
    
    
    
}

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event{
    UITouch *touch=[[event allTouches] anyObject];
    if ([_name isFirstResponder] && [touch view]!=_name) {
        [_name resignFirstResponder];
    }
    if ([_address isFirstResponder] && [touch view]!=_address) {
        [_address resignFirstResponder];
    }
    if ([_phone isFirstResponder] && [touch view]!=_phone) {
        [_phone resignFirstResponder];
    }
    [super touchesBegan:touches withEvent:event];
    
}




- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

- (IBAction)saveData:(id)sender {
    sqlite3_stmt *statement;
    const char *dbpath=[_databasePath UTF8String];
    //DB오픈
    if(sqlite3_open(dbpath, &_contactDB)==SQLITE_OK){
        NSString *insertSQL=[NSString stringWithFormat:@"insert into contacts2(name, address, phone) values('%@','%@','%@')", _name.text,_address.text,_phone.text];
        const char *insert_stmt=[insertSQL UTF8String];
        sqlite3_prepare_v2(_contactDB, insert_stmt, -1, &statement, NULL);
        
        NSLog(insertSQL);
        //insert실행
        if(sqlite3_step(statement)==SQLITE_DONE){
            _status.text=@"입력되었습니다";
            _name.text=@"";
            _address.text=@"";
            _phone.text=@"";
        }else{
            _status.text=@"입력실패";
        }
        sqlite3_finalize(statement);
        sqlite3_close(_contactDB);
    }
}

- (IBAction)findContact:(id)sender {
    sqlite3_stmt *statement;
    const char *dbpath=[_databasePath UTF8String];
    //DB오픈
    if(sqlite3_open(dbpath, &_contactDB)==SQLITE_OK){
       // NSString *querySQL=[NSString stringWithFormat:@"select address, phone from contacts2 where name='%@'", _name.text];//이름으로 검색
        NSString *querySQL=[NSString stringWithFormat:@"select name, address, phone from contacts2 where name like '%%%@%%'", _name.text];//이름으로 검색
        NSLog(querySQL);
        const char *query_stmt=[querySQL UTF8String];
        if(sqlite3_prepare_v2(_contactDB, query_stmt, -1, &statement, NULL)==SQLITE_OK){
            //select실행
              _searchResult.text=@"";
            while(sqlite3_step(statement)==SQLITE_ROW){
                NSString *nameField=[[NSString alloc] initWithUTF8String:(const char *)sqlite3_column_text(statement, 0)];
                NSString *addressField=[[NSString alloc] initWithUTF8String:(const char *)sqlite3_column_text(statement, 1)];
                NSString *phoneField=[[NSString alloc] initWithUTF8String:(const char *)sqlite3_column_text(statement, 2)];
               
               
                _searchResult.text=[_searchResult.text stringByAppendingString:nameField];
                _searchResult.text=[_searchResult.text stringByAppendingString:@"\t"];

                _searchResult.text=[_searchResult.text stringByAppendingString:addressField];
                _searchResult.text=[_searchResult.text stringByAppendingString:@"\t"];

                _searchResult.text=[_searchResult.text stringByAppendingString:phoneField];
                _searchResult.text=[_searchResult.text stringByAppendingString:@"\n"];
                
              //  _phone.text=phoneField;
              //  _address.text=addressField;
              //  _searchResult.text=phoneField;
                
                _status.text=@"검색되었습니다!";
            }
            sqlite3_finalize(statement);
        }
        sqlite3_close(_contactDB);
    }
    
    
    
    
    
}
@end
